"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Nyan = exports.nyanWithEnhancers = exports.NyanRender = exports.nyanWithProps = exports.nyanWithStateShouldShowNyan = exports.NyanComponent = exports.nyanComponentWithEnhancers = exports.componentDidMount = exports.NyanComponentRender = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactHotkeys = require("react-hotkeys");

var _recompose = require("recompose");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var styles = {};
styles.stage = {
  display: 'block',
  position: 'fixed',
  zIndex: 9999,
  left: '50%',
  top: '50%',
  transform: 'translateX(-50%) translateY(-50%)',
  border: 'solid 1px #000'
};
styles.stageContainer = {
  display: 'block',
  position: 'fixed',
  zIndex: 9998,
  left: 0,
  top: 0,
  width: '100vw',
  height: '100vh',
  background: 'linear-gradient( to left, #F44336 6.25%, #E91E63 6.25%, #E91E63 12.5%, #9C27B0 12.5%, #9C27B0 18.75%, #673AB7 18.75%, #673AB7 25%, #3F51B5 25%, #3F51B5 31.25%, #2196F3 31.25%, #2196F3 37.5%, #03A9F4 37.5%, #03A9F4 43.75%, #00BCD4 43.75%, #00BCD4 50%, #009688 50%, #009688 56.25%, #4CAF50 56.25%, #4CAF50 62.5%, #8BC34A 62.5%, #8BC34A 68.75%, #CDDC39 68.75%, #CDDC39 75%, #FFEB3B 75%, #FFEB3B 81.25%, #FFC107 81.25%, #FFC107 87.5%, #FF9800 87.5%, #FF9800 93.75%, #FF5722 93.75%, #FF5722 100%)',
  animation: 'animatedBackground 7.5s linear infinite'
};
styles.stageContainerSpan = {
  color: 'black',
  position: 'absolute',
  bottom: '20px',
  left: '50%',
  transform: 'translateX(-50%)',
  WebkitTouchCallout: 'none',

  /* iOS Safari */
  WebkitUserSelect: 'none',

  /* Safari */
  khtmlUserSelect: 'none',

  /* Konqueror HTML */
  MozUserSelect: 'none',

  /* Firefox */
  msUserSelect: 'none',

  /* Internet Explorer/Edge */
  userSelect: 'none'
  /* Non-prefixed version, currently
      supported by Chrome and Opera */

};
var keyframes = "@keyframes animatedBackground {\n  from {\n    background-position: 0 0;\n  }\n  to {\n    background-position: -100vw 0;\n  }\n}"; // make sure to inherit style and className to not clobber default values

var NyanComponentRender = function NyanComponentRender(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      props = _objectWithoutProperties(_ref, ["style"]);

  return _react.default.createElement("div", _extends({
    style: _objectSpread({}, styles.stageContainer, style)
  }, props), _react.default.createElement("span", {
    style: styles.stageContainerSpan
  }, "Click to play, ESC to close"), _react.default.createElement("canvas", {
    style: styles.stage,
    className: "stage",
    id: "stage",
    width: "400",
    height: "600"
  }));
};

exports.NyanComponentRender = NyanComponentRender;
var colors = ['red', 'orange', 'yellow', 'green', 'blue', 'indigo'];

var _componentDidMount = function componentDidMount(props) {
  // make sure the background animates, yo
  var styleSheet = document.styleSheets[0];
  styleSheet.insertRule(keyframes, styleSheet.cssRules.length);
  var win = window;

  var polyfill = function polyfill(cb) {
    return setTimeout(cb, 1000 / 60);
  };

  var animFrame = function animFrame() {
    return win.requestAnimationFrame || win.webkitRequestAnimationFrame || polyfill;
  };

  win.requestAnimationFrame = animFrame();
  var can = document.getElementById('stage');
  var ctx = can.getContext('2d');
  var wid = can.width;
  var hei = can.height;
  var player;
  var floor;
  var pillars;
  var gravity;
  var thrust;
  var running;
  var rainbows;
  var colider;
  var score;
  var gPat;
  var pPat;
  var trans;
  var termVel;
  var pillGap;
  var pillWid;
  var pillSpace;
  var speed;
  var stars;
  var high;
  var sprite = document.createElement('img');
  sprite.src = 'https://i.stack.imgur.com/0prji.gif';

  sprite.onload = function () {
    sprite.style.height = 0;
    loop();
  };

  sprite.width = 34;
  sprite.height = 21;
  document.body.appendChild(sprite);

  var init = function init() {
    high = localStorage.getItem('high') || 0;
    player = {
      x: 1 / 3 * wid,
      y: 2 / 5 * hei,
      r: 13,
      v: 0
    };
    speed = 2.5;
    floor = 4 / 5 * hei;
    pillars = [];
    rainbows = [];
    stars = [];
    gravity = .25;
    thrust = gravity * -21;
    termVel = -thrust + 2;
    running = false;
    colider = false;
    score = 0;
    trans = 0;
    pillGap = 100;
    pillWid = 55;
    pillSpace = pillWid * 3;

    var createPattern = function createPattern() {
      var can = document.createElement('canvas');
      var ctx = can.getContext('2d');
      can.width = 60;
      can.height = 60;
      colors.forEach(function (color, i) {
        ctx.fillStyle = color;
        ctx.beginPath();
        ctx.moveTo(i * 10, 0);
        ctx.lineTo(i * 10 + 10, 0);
        ctx.lineTo(0, i * 10 + 10);
        ctx.lineTo(0, i * 10);
        ctx.closePath();
        ctx.fill();
        ctx.beginPath();
        ctx.moveTo(i * 10, 60);
        ctx.lineTo(i * 10 + 10, 60);
        ctx.lineTo(60, i * 10 + 10);
        ctx.lineTo(60, i * 10);
        ctx.closePath();
        ctx.fill();
      });
      return can;
    };

    pPat = ctx.createPattern(createPattern(), 'repeat');

    var createPattern2 = function createPattern2() {
      var can = document.createElement('canvas');
      var ctx = can.getContext('2d');
      can.width = 32;
      can.height = 32;
      ctx.save();
      ctx.translate(16, 16);
      ctx.rotate(Math.PI / 4);
      ctx.fillStyle = '#79CDCD';
      ctx.fillRect(-64, -64, 128, 128);
      ctx.fillStyle = '#528B8B';
      ctx.fillRect(-8, -64, 8, 128);
      ctx.fillRect(14.5, -64, 8, 128);
      ctx.restore();
      return can;
    };

    gPat = ctx.createPattern(createPattern2(), 'repeat');
  };

  var render = function render() {
    trans -= speed;
    rainbows = rainbows.filter(function (r) {
      r.x -= speed;
      return r.x > -speed;
    });

    if (trans % speed === 0) {
      rainbows.push({
        x: player.x - 10,
        y: player.y - (trans % 50 / 25 | 0) * 2 - 1
      });
    }

    stars = stars.filter(function (s) {
      trans % 10 || (s.r += 1);
      s.x -= speed;
      return s.x > -speed && s.r < 10;
    });

    if (trans % 20 === 0) {
      stars.push({
        x: Math.round(Math.random() * (wid - 50) + 100),
        y: Math.round(Math.random() * floor),
        r: 0
      });
    } // backdrop


    ctx.fillStyle = 'black';
    ctx.fillRect(0, 0, wid, hei); // stars

    ctx.fillStyle = 'white';
    stars.forEach(function (s) {
      ctx.fillRect(s.x, s.y - s.r - 2, 2, s.r / 2);
      ctx.fillRect(s.x - s.r - 2, s.y, s.r / 2, 2);
      ctx.fillRect(s.x, s.y + s.r + 2, 2, s.r / 2);
      ctx.fillRect(s.x + s.r + 2, s.y, s.r / 2, 2);
      ctx.fillRect(s.x + s.r, s.y + s.r, 2, 2);
      ctx.fillRect(s.x - s.r, s.y - s.r, 2, 2);
      ctx.fillRect(s.x + s.r, s.y - s.r, 2, 2);
      ctx.fillRect(s.x - s.r, s.y + s.r, 2, 2);
    }); // ground

    ctx.fillStyle = '#2F4F4F';
    ctx.fillRect(0, floor, wid, hei - floor);
    ctx.save();
    ctx.translate(trans, 0); // pillars

    ctx.fillStyle = pPat;
    ctx.strokeStyle = '#ccc';
    ctx.lineWidth = 2;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = pillars[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var pill = _step.value;
        ctx.fillRect(pill.x, pill.y, pill.w, pill.h);
        ctx.strokeRect(pill.x, pill.y, pill.w, pill.h);
      } // stripe

    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    ctx.fillStyle = gPat;
    ctx.fillRect(-trans, floor + 2, wid, 15);
    ctx.restore(); // rainbowwwwws

    rainbows.forEach(function (r) {
      colors.forEach(function (color, i) {
        ctx.fillStyle = color;
        ctx.fillRect(r.x - speed, r.y - 9 + i * 3, speed + 1, 3);
      });
    }); // player

    ctx.save();
    ctx.translate(player.x, player.y);
    ctx.rotate(player.v * Math.PI / 18);
    ctx.drawImage(sprite, -17, -10);
    ctx.restore();
    ctx.fillStyle = '#97FFFF';
    ctx.fillRect(0, floor, wid, 2);
    ctx.fillStyle = '#2F4F4F';
    ctx.fillRect(0, floor + 1, wid, 1);
    ctx.fillStyle = '#97FFFF';
    ctx.fillRect(0, floor + 17, wid, 2);
    ctx.fillStyle = '#2F4F4F';
    ctx.fillRect(0, floor + 17, wid, 1); // score

    ctx.font = 'bold 30px monospace';
    var hScore = 'best:' + (score > high ? score : high);
    var sWid = ctx.measureText(hScore).width;
    var sY = 50;
    ctx.fillStyle = 'black';
    ctx.fillText(score, 12, floor + sY + 2);
    ctx.fillText(hScore, wid - sWid - 10, floor + sY + 2);
    ctx.fillStyle = 'white';
    ctx.fillText(score, 10, floor + sY);
    ctx.fillText(hScore, wid - sWid - 12, floor + sY);
  };

  var adjust = function adjust() {
    if (trans % pillSpace === 0) {
      var h;
      pillars.push({
        x: -trans + wid,
        y: 0,
        w: pillWid,
        h: h = Math.random() * (floor - 300) + 100
      });
      pillars.push({
        x: -trans + wid,
        y: h + pillGap,
        w: pillWid,
        h: floor - h - pillGap
      });
    }

    pillars = pillars.filter(function (pill) {
      return -trans < pill.x + pill.w;
    });
    player.v += gravity;

    if (player.v > termVel) {
      player.v = termVel;
    }

    player.y += player.v;

    if (player.y < player.r) {
      player.y = player.r;
      player.v = 0;
    }

    for (var i in pillars) {
      var pillIndex = i;
      var pill = pillars[pillIndex];

      if (pill.x + trans < player.x + player.r && pill.x + pill.w + trans > player.x - player.r) {
        if (player.y - player.r > pill.y && player.y - player.r < pill.y + pill.h) {
          colider = true;
          running = false;
          render();
          break;
        }

        if (player.y + player.r < pill.y + pill.h && player.y + player.r > pill.y) {
          colider = true;
          running = false;
          render();
          break;
        }

        if (!pill.passed && pillIndex % 2 == 1) {
          score += 1;
          pill.passed = true;
        }
      }
    }

    if (player.y + player.r - player.v > floor) {
      player.y = floor - player.r;
      running = false;
      colider = true;
      render();
    }
  };

  document.onmousedown = function () {
    if (running) {
      player.v = thrust;
    } else if (!colider) {
      running = true;
    } else {
      if (score > high) {
        localStorage.setItem('high', score);
      }

      init();
    }
  };

  init();

  function loop() {
    if (running) {
      adjust();
    }

    if (!colider) {
      render();
    }

    requestAnimationFrame(loop);
  }
};

exports.componentDidMount = _componentDidMount;
var withLifecycle = (0, _recompose.lifecycle)({
  componentDidMount: function componentDidMount() {
    _componentDidMount(this.props);
  }
});
var nyanComponentWithEnhancers = (0, _recompose.compose)(withLifecycle);
exports.nyanComponentWithEnhancers = nyanComponentWithEnhancers;
var NyanComponent = nyanComponentWithEnhancers(NyanComponentRender);
exports.NyanComponent = NyanComponent;
var nyanWithStateShouldShowNyan = (0, _recompose.withState)('shouldShowNyan', 'setShouldShowNyan', false);
exports.nyanWithStateShouldShowNyan = nyanWithStateShouldShowNyan;
var nyanWithProps = (0, _recompose.withProps)(function (_ref2) {
  var hotkey = _ref2.hotkey,
      props = _objectWithoutProperties(_ref2, ["hotkey"]);

  return _objectSpread({}, props, {
    keyMap: {
      escModifier: 'esc',
      nyan: hotkey || 'command+alt+shift+ctrl+n'
    },
    keyHandlers: {
      escModifier: function escModifier() {
        if (props.shouldShowNyan) {
          props.setShouldShowNyan(false);
        }
      },
      nyan: function nyan() {
        return props.setShouldShowNyan(true);
      }
    }
  });
});
exports.nyanWithProps = nyanWithProps;

var NyanRender = function NyanRender(_ref3) {
  var keyMap = _ref3.keyMap,
      keyHandlers = _ref3.keyHandlers,
      setShouldShowNyan = _ref3.setShouldShowNyan,
      shouldShowNyan = _ref3.shouldShowNyan,
      props = _objectWithoutProperties(_ref3, ["keyMap", "keyHandlers", "setShouldShowNyan", "shouldShowNyan"]);

  return _react.default.createElement(_reactHotkeys.HotKeys, {
    keyMap: keyMap,
    focused: true,
    handlers: keyHandlers,
    attach: window
  }, shouldShowNyan && _react.default.createElement(NyanComponent, props));
};

exports.NyanRender = NyanRender;
var nyanWithEnhancers = (0, _recompose.compose)(nyanWithStateShouldShowNyan, nyanWithProps);
exports.nyanWithEnhancers = nyanWithEnhancers;
var Nyan = nyanWithEnhancers(NyanRender);
exports.Nyan = Nyan;
var _default = Nyan;
exports.default = _default;